#include <avr/io.h>



#ifndef F_CPU
#define F_CPU 4000000UL
#endif

#define UART_BAUD_RATE 9600
// Hilfsmakro zur UBRR-Berechnung ("Formel" laut Datenblatt) 
#define UART_UBRR_CALC(BAUD_,FREQ_) ((FREQ_)/((BAUD_)*16L)-1)





void init_uart(void)
{
	UCSRA &= ~(1<<U2X);
  UCSRB |= (1<<TXEN);  //Transmitter Enabled
  UCSRC |= (1<<URSEL) | (3<<UCSZ0);  //Asynchron 8N1
  
  UCSRB |= (1<<RXEN);  //Emfpang enabl

  UBRRH=(uint8_t) (UART_UBRR_CALC(UART_BAUD_RATE,F_CPU)>>8);
  UBRRL=(uint8_t)UART_UBRR_CALC(UART_BAUD_RATE,F_CPU);
  //UBRRH=0;
  //UBRRL= 25;  //19200 -> 25,0416

  //UCSRB |= (1<<RXCIE); //Ev. Fr ISR
}




int uart_putc(unsigned char c)
{
  while (!(UCSRA & (1<<UDRE))); // wait for empty (UartDataRegisterEmpty) transmit buffer
  UDR = c; // put data into buffer, sends the data
  //UDR = 'a';
  return 0;
}



void uart_intout(int zahl)
{unsigned int mod=10,durch=1;
 long int temp;
 //Variablen der Lngenerkenung
 int laenge=0;

	//Ermittlung der anzahl der Stellen in der Variabl Bsp: 123 -> 3 Stellen
	do{	laenge++;
		durch=durch*10;
	}while(zahl/durch>0);
	durch = 1;   //Reset der "durch" Variable
	
 //uart_putc('-');
 	//Ausgabe der einzelnen Stellenwerte, von links nach rechts (Fr USART oder der Gleichen)
	int i,j, modtemp, durchtemp;
	for(i=laenge; i>0; i--)
	{	
		modtemp= mod;
		durchtemp = durch;
		for(j=1; j<i; j++) //Berechnen des Modulu und des Dividenden
		{	modtemp *= 10;
			durchtemp *=10;
		}
		temp=(zahl%modtemp)/durchtemp;
		uart_putc(temp+48); //Ausgabe
	}
 
	/*// Ausgabe der einzelnen Stellenwerte, von rechts nach links (Fr LCD-Displays oder der Gleichen)
	do
	{temp=(zahl%mod)/durch;
		if(zahl/durch <10) //Wenn es die letzte auszugebende Zahl ist, verndert sich die Berechnung der Ausgabe
  			temp=zahl/durch;
		mod *= 10;
		durch *= 10;
		temp += 48;
		uart_putc(temp); //Ausgabe
	}while (zahl/durch > 0); //End While */
 //uart_putc('-'); 
}



//Folgendes ist noch nicht richtig implementiert


/*************************************************************************
Function: uart_puts()
Purpose:  transmit string to UART
Input:    string to be transmitted
Returns:  none          
**************************************************************************/
void uart_puts(const char *s )
{
    while (*s) 
      uart_putc(*s++);

}/* uart_puts */



/*************************************************************************
Function: uart_puts_p()
Purpose:  transmit string from program memory to UART
Input:    program memory string to be transmitted
Returns:  none
**************************************************************************/
/*void uart_puts_p(const char *progmem_s )
{
    register char c;
    
    while ( (c = pgm_read_byte(progmem_s++)) ) 
      uart_putc(c);

}// uart_puts_p */
